/* $Id: Bank.java 2269 2013-12-01 02:33:37Z terescoj $ */
/*
 * Class that represents a bank with two ATM's making deposits and withdrawals.
 * This program was designed to illustrate problems with concurrency.
 * Written 11/26/99 by Kim Bruce.
 * Changed 3/16/99 by Barbara Lerner to use a different UI showing just current values, not
 * a transaction history.
 * 
 * @author updated by Jim Teresco, Siena College, Spring 2011
 * Further updated for Swing and to remove dependency on Objectdraw
 * by Jim Teresco, The College of Saint Rose, Fall 2013, CSC 252
 */

import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

// note that since this class does not need ObjectDraw but does have Java Swing
// components, we extend "JApplet" instead of "WindowController"
public class Bank extends JApplet implements ActionListener {

    private static final int INITIAL_BALANCE = 1000;        // Initial balance in bank account
    private static final int TRANSACTION_AMOUNT = 100;      // how much to deposit/withdraw per xaction

    private JLabel currentBalanceLabel;
    private JLabel withdrawTotalLabel;
    private JLabel depositTotalLabel;

    // Set up window layout and two ATM threads
    // The init method is the JApplet equivalent of a WindowController's begin method
    public void init() {

        JLabel startBalance = new JLabel("Starting balance:  " + INITIAL_BALANCE, JLabel.CENTER);
        JLabel currentLabel = new JLabel("Current balance:  ", JLabel.RIGHT);
        currentBalanceLabel = new JLabel("" + INITIAL_BALANCE + "     ", JLabel.LEFT);
        JLabel withdrawLabel = new JLabel("Amount withdrawn:  ", JLabel.RIGHT);
        withdrawTotalLabel = new JLabel("         0    ", JLabel.LEFT);
        JLabel depositLabel = new JLabel("Amount deposited:  ", JLabel.RIGHT);
        depositTotalLabel = new JLabel("         0    ", JLabel.LEFT);

        setLayout(new GridLayout(0, 1));
        this.setFont(new Font("System", Font.PLAIN, 18));

        add(startBalance);

        JPanel balancePanel = new JPanel();
        balancePanel.add(currentLabel);
        balancePanel.add(currentBalanceLabel);
        add(balancePanel);

        JPanel withdrawPanel = new JPanel();
        withdrawPanel.add(withdrawLabel);
        withdrawPanel.add(withdrawTotalLabel);
        add(withdrawPanel);

        JPanel depositPanel = new JPanel();
        depositPanel.add(depositLabel);
        depositPanel.add(depositTotalLabel);
        add(depositPanel);

        JPanel buttonPanel = new JPanel();
        JButton runIt = new JButton("Run demo");
        buttonPanel.add(runIt,"South");
        add(buttonPanel);
        runIt.addActionListener(this);

    }

    // Run the demo each time the button is pressed.
    public void actionPerformed(ActionEvent evt) {
        
        Account account = new Account(INITIAL_BALANCE, currentBalanceLabel);
        ATM atm1 = new ATM(account, 100, depositTotalLabel);
        ATM atm2 = new ATM(account, -100, withdrawTotalLabel);
    }
}
